
/*
 * Performance event assistance functions
 */

/* 
 * Author:  P.J. Drongowski
 * Site:    sandsoftwaresound.net
 * Version: 1.0
 * Date:    19 November 2020
 *
 * Copyright (c) 2020 Paul J. Drongowski
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#define  PE_MAX_GROUPS  1
#define  PE_MAX_EVENTS  6

/*
 * Exported functions
 */
extern int peInitialize() ;
extern int peMakeGroup(int num, pid_t pid, int cpu, unsigned long flags) ;
extern int peAddLeader(long unsigned etype, long unsigned econfig) ;
extern int peAddEvent(long unsigned etype, long unsigned econfig) ;
extern int peStartCounting() ;
extern int peStopCounting() ;
extern int peResetCounters() ;
extern long long peReadCount(int eindex) ;
extern void pePrintCount(FILE* stream, int eindex, char *legend) ;

extern int peMeasureInstructionEvents() ;
extern int pePrintInstructionEvents() ;

extern int peMeasureDataAccessEvents() ;
extern int pePrintDataAccessEvents() ;




