
/*
 * Performance event assistance functions - Test driver
 */

/* 
 * Author:  P.J. Drongowski
 * Site:    sandsoftwaresound.net
 * Version: 1.0
 * Date:    19 November 2020
 *
 * Copyright (c) 2020 Paul J. Drongowski
 */

#include "pe_assist.h"

/*
 * Burn instructions and cycles.
 */
long long unsigned int spin_wheels(long long unsigned int iterations)
{
  long long unsigned int sum = 0 ;
  long long unsigned int i = 0 ;
  sum = 0 ;
  for (i = iterations ; i > 0 ; i--) {
    sum = sum + i ;
  }
  return( sum ) ;
}

/*
 * Test driver
 */
int main(int argc, char **argv)
{
  long long unsigned int sigma = 0 ;

  // Measure events related to fetch and branching
  peMeasureInstructionEvents() ;
  
  // Clear and start the counters
  peStartCounting() ;

  // Do the workload
  sigma = spin_wheels(2000000000) ;
  printf("Sigma: %lld\n", sigma) ;

  // Stop the counters
  peStopCounting() ;

  // Print results
  pePrintInstructionEvents(stdout) ;
}
