
/*
 * Performance event assistance functions - Test driver
 */

/* 
 * Author:  P.J. Drongowski
 * Site:    sandsoftwaresound.net
 * Version: 1.0
 * Date:    19 November 2020
 *
 * Copyright (c) 2020 Paul J. Drongowski
 */

#include <stdlib.h>
#include <stdio.h>

#define ROWS     1000 
#define COLUMNS  1000

double matrix_a[ROWS][COLUMNS] ; // Left matrix operand
double matrix_b[ROWS][COLUMNS] ; // Right matrix operand
double matrix_r[ROWS][COLUMNS] ; // Matrix result

void initialize_matrices()
{
  // Define initial contents of the matrices
  for (int i = 0 ; i < ROWS ; i++) {
    for (int j = 0 ; j < COLUMNS ; j++) {
      matrix_a[i][j] = (float) rand() / RAND_MAX ;
      matrix_b[i][j] = (float) rand() / RAND_MAX ;
      matrix_r[i][j] = 0.0 ;
    }
  }
}

void multiply_matrices()
{
  // Multiply the two matrices
  for (int i = 0 ; i < ROWS ; i++) {
    for (int j = 0 ; j < COLUMNS ; j++) {
      float sum = 0.0 ;
      for (int k = 0 ; k < COLUMNS ; k++) {
        sum = sum + matrix_a[i][k] * matrix_b[k][j] ;
    }
    matrix_r[i][j] = sum ;
    }
  }
}

int main(int argc, char **argv)
{
  initialize_matrices() ;

  multiply_matrices() ;
}
